#ifndef __SNESADDRESS_H_
#define __SNESADDRESS_H_

#include "SNESstructures.h"
#include "SNESregisters.h"
#include "SNESmemory.h"

Double special();
/////////////////////////////////////////////Immediate Addressing -> #
Double immediate();
Byte immediateVb();
Word immediateVw();
/////////////////////////////////////////////Absolute -> a
Double absolute();
Byte absoluteVb();
Word absoluteVw();
/////////////////////////////////////////////Absolute Long -> al
Double absolute_long();
Byte absolute_longVb();
Word absolute_longVw();
/////////////////////////////////////////////Direct -> d
Double direct();
Byte directVb();
Word directVw();
/////////////////////////////////////////////Accumulator -> A
Word accumulatorV();
/////////////////////////////////////////////Implied -> i
Double implied();
/////////////////////////////////////////////Direct Indirect Indexed -> (d),y
Double direct_indir_indexed_y();
Byte direct_indir_indexed_yVb();
Word direct_indir_indexed_yVw();
/////////////////////////////////////////////Direct Indirect Indexed Long -> [d],y
Double dir_indir_indexed_long();
Byte dir_indir_indexed_longVb();
Word dir_indir_indexed_longVw();
/////////////////////////////////////////////Direct Indexed Indirect -> (d,x)
Double direct_indexed_indir();
Byte direct_indexed_indirVb();
Word direct_indexed_indirVw();
/////////////////////////////////////////////Direct Indexed with X -> d,x
Double direct_indexed_x();
Byte direct_indexed_xVb();
Word direct_indexed_xVw();
/////////////////////////////////////////////Direct Indexed with Y -> d,y
Double direct_indexed_y();
Byte direct_indexed_yVb();
Word direct_indexed_yVw();
/////////////////////////////////////////////Absolute Indexed with X -> a,x
Double absolute_Xindexed();
Byte absolute_XindexedVb();
Word absolute_XindexedVw();
/////////////////////////////////////////////Absolute Indexed with Y -> a,y
Double absolute_Yindexed();
Byte absolute_YindexedVb();
Word absolute_YindexedVw();
/////////////////////////////////////////////Absolute Long Indexed with X -> al,x
Double absolute_long_indexed();
Byte absolute_long_indexedVb();
Word absolute_long_indexedVw();
/////////////////////////////////////////////Program Counter Relative -> r
Double relative();
/////////////////////////////////////////////Program Counter Relative Long -> rl
/////////////////////////////////////////////Absolute Indirect -> (a)
Byte absolute_indir();
/////////////////////////////////////////////Direct Indirect -> (d)
Double direct_indir();
Byte direct_indirVb();
Word direct_indirVw();
/////////////////////////////////////////////Direct Indirect Long -> [d]
Double direct_indir_long();
Word direct_indir_longVw();
Byte direct_indir_longVb();
/////////////////////////////////////////////Absolute Indexed Indirect -> (a,x)
Double absolute_indexed_indir();
/////////////////////////////////////////////Stack -> s
/////////////////////////////////////////////Stack Relative -> d,s
Double stack_relative();
Word stack_relativeVw();
Byte stack_relativeVb();
/////////////////////////////////////////////Stack Relative Indirect Indexed -> (d,s),y
Double stack_relative_indir_indexed();
Word stack_relative_indir_indexedVw();
Byte stack_relative_indir_indexedVb();
/////////////////////////////////////////////Block Source Bank, Destination Bank -> xyc
void block_src_bank_dest_bank(Double *src,Double *dest);

#endif